\section{Analysis Result on well-known web applications}
A key aspect of the implementation stage was the testing phase: we had to decide how and on what platform we would check the newly implemented features.

We decided to focus on a single web app which offers the possibility of logging in with multiple Identity Providers. This allowed us to concentrate purely on the reliability of checks and not on the structure itself.

Figures \ref{fig:webappprovider1}, \ref{fig:webappprovider2} and \ref{fig:webappprovider3} provide a graphical representation of the results a complete run of the plugin, which give and idea of what a well-known website is missing from a security point of view. 

Every provider lack three key security measure: prevent clickjacking, block for referrer header and external javascript. This can lead to a wide variety of vulnerabilities and all not applied features are suggested in the current best practices.

More importantly, all these web services \textit{do not} implement state parameter, PKCE, or even both, extension/parameter that were created to ensure security over multiple attacks, like replay attacks or CSRF.

\begin{figure}[h]
	\resizebox{\textwidth}{!}{
		\includegraphics{imdbwithamazonblurred.png}}
	\caption{Checks result web app - provider 1}
	\label{fig:webappprovider1}
\end{figure}

\begin{figure}
	\resizebox{\textwidth}{!}{
		\includegraphics{imdbwithgoogleblurred.png}}
	\caption{Checks result web app provider 2}
	\label{fig:webappprovider2}
\end{figure}

\begin{figure}
	\resizebox{\textwidth}{!}{
		\includegraphics{imdbwithfacebookblurred.png}}
	\caption{Checks result web app - provider 3}
	\label{fig:webappprovider3}
\end{figure}

\newpage